//Multipaint 2024 alpha
//Tero Heikkinen (Dr. Terrorz)

//processing setup() draw() things here

//force set machine at beginning of setup()

DisposeHandler dh;
//boolean g_wizard=true;
boolean g_wizard=false;
int debugger=-1;
int g_machine;
int g_timer;//zx flash maybe
int g_banctr=0;

int g_relevel;

int g_screenw=width;
int g_screenh=height;

final int COMMAND=157; // Marq's cmd/ctrl solution

int g_active,g_tooltrigger,g_prevtool;
int g_rband,g_rbang,g_boxreconstruct,g_sorsaa,g_charlimit;
int g_animx,g_animy,g_animframes,g_animno,g_animtime,g_animspeed;
int g_omag,g_bordh,g_bordv,g_keymacpos;

String g_keymacro="";

int[] g_r = new int[266];int[] g_g = new int[266];int[] g_b = new int[266];
int[] g_rgb = new int[266];

byte[] g_map = new byte[88000];
byte[] g_readbuffer = new byte[88000];
byte[] g_rmap = new byte[88000];
byte[] g_icons = new byte[88000];
byte[] g_brush = new byte[88000];
byte[] g_template = new byte[16384];
byte[] g_redo = new byte[80*64];
byte[] g_remdo = new byte[80*64];
int[] g_chaup = new int[64];
int [] g_magpix = new int[256];
int [] g_magpiy = new int[256];

byte g_realfront,g_realback;
String g_name;

//dimensions
int X,Y,MX,MY;
int CX,CY;
int CXM;
//generic mouse
int g_ofx,g_ofy,g_button,g_realbutton,g_klikkeri,g_mx,g_my,g_orx,g_ory,g_msx,g_msy;
//rubberband,mouse
int g_phase,g_rx,g_ry,g_rx2,g_ry2,g_rubbermode;
int g_prex,g_prey,g_storedcoordx,g_storedcoordy;
//window positioning
int g_windowx,g_windowy,g_maglocx,g_maglocy;
int g_hedge,g_vedge,g_uizoom,g_wzoom;
//icons & gui stuff
int g_iconx,g_icony,g_piconx,g_picony,g_iconmode;
int g_gridx,g_gridy,g_spare;
int g_farge,g_backg,g_ofarge,g_repanel,g_msgctr;
//machine related color properties
int g_attrimode,g_britemode,g_multic,g_backmode,g_maxcolors,g_hzoomer;
float g_palsteps;
//brush, tool parameters
int g_bsourcex,g_bsourcey,g_bsourcex2,g_bsourcey2;
int g_bsize,g_btype;

int g_mirrorx=240;
int g_mirrory=40;

int g_trustorex;
int g_trustorey;

int paspect;

PImage actual;

void settings(){
  size(1024,752);
  noSmooth();
  actual=createImage(320,200,RGB);
}

void setup(){
  delay(225);//Marq's solution for linux resize bug, needed
  surface.setResizable(true);
  delay(225);//needed
  startup_sequence();
  dh=new DisposeHandler(this);//for autosave in all exits
  PSurfaceAWT.SmoothCanvas sur=(PSurfaceAWT.SmoothCanvas)surface.getNative();
  JFrame j=(JFrame)sur.getFrame();
  j.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
}

int g_argread=0;

String g_superpath="";

// some arguments are done prior to creating window&mode
// and some after it

void getargs(int priority){
  if (args != null) {
    println("No. of args ="+args.length);
    for (int i = 0; i < args.length; i++) { 
        if(args[i].length()>3){
          cline(args[i],priority);  
      }  
    }
  } else {
    println("args == null");
  }
}

// setup things and create window initially
// is never run again

void startup_sequence()
{
  int i,x,y;
  
  g_machine=0;
  
  //machine=BBCLOW;
  
  // for experimental or incomplete modes
  // try machine=ATARIST, AMIGA or PICO8, BK0010, COCO3, C64NOLIMIT, TIMEX
  // without proper export & may not work at all
  
  g_uizoom=2;
  g_animspeed=1;
  
  create_aspects();  
  store_c64_palettes();
  
  getargs(0); //High priority (PRE) args
  
  g_omag=1;
  g_bordh=64;
  g_bordv=72;
  
  gui_colors();
  for(i=0;i<256;i++){
    g_usablecolor[i]=255;
  }
  boolean prefs_loaded=pref_runner();
      
  javatheme();//Marq again
  
  if(g_uizoom>=1&&g_uizoom<=3)g_wzoom=g_uizoom+1;
 
  // collars (will be set elsewhere?)
  
  g_hedge=g_uizoom*40;
  g_vedge=g_uizoom*32;
  
  // parameters
  
  reset_parameters();
  
  icon_loader();
  
  set_tool(3);
  putbit(136,0);//border exp OFF image specific
  putbit(128,1);//text comments on image specific
  
  //g_gridx=8;g_gridy=8;
  g_multic=0;
  g_repanel=-2;
  
  set_console();
  
  set_machine(g_machine);
  g_pal_aspect=g_realaspect;
  
  create_aspects();
  resize_preview();
  
  refocus();
  
  int XLOOK=320;
  int YLOOK=204;
  int truwinsizex=XLOOK*g_magpix[magmode()];
  int truwinsizey=YLOOK*g_magpiy[magmode()];
  
  if(g_forcedpalette.length()>3)palette_loader(g_forcedpalette);

  int hsize=truwinsizex+g_hedge+(42)*g_wzoom;//22
  int vsize=truwinsizey+g_vedge+(14)*g_wzoom;
  println("Opening window sized: "+hsize+" x "+vsize);
  surface.setSize(hsize, vsize);
    
  //now we have size, can do this
  
  reset_windows();
  
  switcher(3);
  
  g_map[4]=byte(g_maxcolors-1);
  g_ofarge=g_farge;
  MX=X/8;
  MY=round(Y/8);
  
  make_grid(8,8);
  
  g_realfront=byte(g_farge);
  g_realback=byte(g_backg);
  
  wipe_out();

  switcher(2);
  
  noStroke();
  background(g_r[263],g_g[263],g_b[263]);
  
  sussborder();
  
  setup_raster();
  
  message("Multipaint|   2029||");
  message("*");
  

  untouch();
  reboot();
  g_hardboot=false;  
  if(prefs_loaded==true){
    x_com(0,"MODE",0,0,0);
  }else{
    launch_dialogue(75);
  }
  
  refocus();
}

// main draw loop

void draw()
{
  int msx,msy;
      try { Thread.sleep(2); }
      catch(Exception e){
      };
  
  
  g_ccontroller=1;
  //resize here
  
  if (g_screenw!=width||g_screenh!=height) {    
    g_screenw=width;
    g_screenh=height;
    if(g_data[GUILOCK]==0)re_scale();
    g_repanel=-2;
    g_trueclearbit=true;    
  }    
  
  g_mousex=mouseX;
  g_mousey=mouseY;
  
  if(!focused){
    g_control=false;
    g_shift=false; 
    delay(100);
  }
  
  // get mirrors
  
  g_mirrorx=deek(24);
  g_mirrory=deek(26);
  if(g_mirrorx==0&&g_mirrory==0){
    make_mirror(X/2-1,Y/2-1);
  }
  // animbrush active
  
  if(g_data['n']==1){  
      g_animtime++;
      if(g_animtime>8-g_animspeed*2){
        animbrush_do();
        g_animtime=0;  
    }
  }

  //timer for gui anims
  
  g_timer++;
  if(g_timer>50)g_timer=0;
  
  // mousecoord stuff
  
  if(g_maglevel==-1){
    msx=g_mousex-g_windowx;
    msy=g_mousey-g_windowy;
    msx=g_msx-g_windowx;
    msy=g_msy-g_windowy;
  }
  else
  {
    msx=mouseX;
    msy=mouseY-get_topedge();
  }
  
  g_mx=msx;
  g_my=msy;
 
 //actual tool drawing
 
  if(g_tooltrigger==1){ // comes from mousepressed, or mousedragged
   // if(g_mx<=width-g_hedge&&g_my<=height-g_vedge){
      do_tool(msx,msy,g_button);
   // }
  }    
  
  g_msx=mouseX;
  g_msy=mouseY; 
  
  // infer scrolling in magnify mode
  // inferred panning
  
  inferpan();
    
  //some FX modes need this, a bit brutal
  
  if(g_data[FX]==SMEAR||g_data[FX]==BLENDER){
    memorizepoints();
  }
  
  //cloner 1 of 2
  
  switcher(0);
  int rememberbutton=g_button;
  
  //tool drawing for shows
  
  int ih=in_window_type(g_mousex,g_mousey);
  int show=1;  
  
  if(ih==102||g_phase>0){
    if(tool()==13){
      cursor_state(MOVE);
    }
  }else{
    cursor_state(ARROW);
  }
  
  if((ih>=32 && ih<90))show=0;  
  if(tool()==0)show=1;
  if(g_btype==9 && g_phase==0){
    if(ih!=102)show=0;
  }
  
  if(show==1){
    clear_fxtrigger(0);
    if(tool()!=5){
       if(g_phase==0)g_button=LEFT;
       do_tool(msx,msy,LEFT);
    }
    
    if(tool()==5)storecoords(msx,msy);
    
    if(tool()==6)doline(g_rx,g_ry,g_rx2,g_ry2,0);
    if(tool()==7)docircle(g_rx,g_ry,g_rx2,g_ry2);
    if(tool()==8)rectangle(g_rx,g_ry,g_rx2,g_ry2);
    g_button=rememberbutton; 
  }
   
  if(g_trueclearbit){ // probably not needed anymore
    g_trueclearbit=false;
   // fill(g_rgb[263]);
    //rect(0,0,width-1,height-1);
    g_repanel=-2;
    update_ui(false,0);
  }
  
  viewport();

  //cloner 2 of 2
  
  byte force=g_map[12];
  switcher(1);
  g_map[12]=force;
  
  if(g_global_dragmode==1)all_box_drag();
  
  update_ui(false,0);
      
  if(g_msgctr>0){
    g_msgctr--;
    if(g_msgctr==0)g_iconban=false;
  }
  if(g_banctr>0){
    g_banctr--;
    if(g_banctr==0)g_iconban=false;
  }
  
  if(g_markctr>0&&g_phase==0){
    g_markctr--;
    if(g_markctr==0)reset_marked();
  }
  
  if(gui){
    g_fingernumb=0;
    gui_stuff();
    gui=false;
    g_msgctr=10;
    g_fingernumb=1;
  }
  
  if(g_keymacro.length()>g_keymacpos){
    macro_command(g_keymacro.charAt(g_keymacpos));
    g_keymacpos++;
  }
  
  if(g_argread==0){
    getargs(1);//low priority (POST) args
    g_argread=1;
  }
  
  if(g_fxtrigger==1){
    if(g_map[12]!=3||g_phase==0)fxmap_clear();
  }
  
  if(g_phase==0){
    for(int i=0;i<256;i++){
      auto_histogrammer();
    }
    if(g_machine==C64M){
      for(int i=0;i<16;i++){    
        unique_chars();
      }
    }
    
  }
}
